/************************************************************************************
*
*  Project Name:	CTBRegisterInit
*     File Name:	CTBRegisterInit.r
*        Author:	Glenn L. Austin
*          Date:	February 15, 1989
*
*   Description:	These are the resources needed to register a serial card.
*
*************************************************************************************
*
*	Revision History:
*		2/15/89 - Original version by Glenn L. Austin
*
************************************************************************************/

#include "Types.r"

resource 'STR#' (1200, "CTBCard Resources") {
	{
		"CardName",
		"CTBCard",
		" Slot ",
		" Port ",
		".CTBCardIn",
		".CTBCardOut",
		"2"
	}
};

resource 'ICN#' (1200, "CTBCard") {
	{	/* array: 2 elements */
		/* [1] */
		$"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00"
		$"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00"
		$"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00"
		$"00 00 00 00 00 00 00 00 FF FF FF FF 00 00 00 01"
		$"7B DE F7 BD 4A 52 94 A5 4A 52 94 A5 4A 52 94 A5"
		$"4A 52 94 A5 4A 52 94 A5 4A 52 94 A5 4A 52 94 A5"
		$"4A 52 94 A5 4A 52 94 A5 4A 52 94 A5 4A 52 94 A5"
		$"7B DE F7 BD 00 00 00 01 FF FF FF FF 00 00 00 00",
		/* [2] */
		$"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00"
		$"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00"
		$"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00"
		$"00 00 00 00 00 00 00 00 FF FF FF FF FF FF FF FF"
		$"FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF"
		$"FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF"
		$"FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF"
		$"FF FF FF FF FF FF FF FF FF FF FF FF 00 00 00 00"
	}
};

resource 'ICN#' (1201, "No CTBCard") {
	{	/* array: 2 elements */
		/* [1] */
		$"C0 00 00 03 E0 00 00 07 70 00 00 0E 38 00 00 1C"
		$"1C 00 00 38 0E 00 00 70 07 00 00 E0 03 80 01 C0"
		$"01 C0 03 80 00 E0 07 00 00 70 0E 00 00 38 1C 00"
		$"00 1C 38 00 00 0E 70 00 FF FF FF FF 00 03 C0 01"
		$"7B DF F7 BD 4A 57 F4 A5 4A 5E F4 A5 4A 5E BC A5"
		$"4A 7A 9C A5 4A 72 9E A5 4A F2 97 A5 4B D2 97 A5"
		$"4B D2 95 E5 4F 52 94 F5 4E 52 94 F5 5E 52 94 BD"
		$"7B DE F7 BD 60 00 00 0F FF FF FF FF C0 00 00 03",
		/* [2] */
		$"C0 00 00 03 E0 00 00 07 70 00 00 0E 38 00 00 1C"
		$"1C 00 00 38 0E 00 00 70 07 00 00 E0 03 80 01 C0"
		$"01 C0 03 80 00 E0 07 00 00 70 0E 00 00 38 1C 00"
		$"00 1C 38 00 00 0E 70 00 FF FF FF FF FF FF FF FF"
		$"FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF"
		$"FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF"
		$"FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF"
		$"FF FF FF FF FF FF FF FF FF FF FF FF C0 00 00 03"
	}
};

type 'sysz' {
	longint;
};

resource 'sysz' (0, "System Heap Requirements") {
	1024*7
};
