/* ================================================================== **

	Purpose:		Terminal tool main resource module.  Here
		is where we define our simple check boxes for the 
		TMChoose dialog, and also our config strings because
		this tool utilizes them. 

	Module :		tbnd.r

	Authors:		Craig Hotchkiss, Alex Kazim, Byron Han, 
						Carol Lee
					Apple Computer, Inc.
					Networks & Communications
					20525 Mariani Drive
					Cupertino, CA 95014

	Version :		1.0d1

	Date :			9.may.89

	History :
		9.may.89	Creation date


	1989 Apple Computer, Inc.  All Rights Reserved.
	This software is proprietary to Apple Computer, Inc.
	It may not be copied, in whole or in part,
	without the written consent of Apple Computer, Inc.

** ==================================================================== */


#include "SysTypes.r"
#include "Types.r"
#include "TMTypes.r"



resource 'tbnd' (1, "Terminal") {
	{	 
		'DITL',  
		{
		1, 31000
		},
		'STR#',
		{
		0, 31000,
		1, 31001
		}
	}
};

resource 'STR#' (31000, "Config: English") {
	{	/* array StringArray: 5 elements */
		/* [1] */
		"onlineBoolean",
		/* [2] */
		"screen132Boolean",
		/* [3] */
		"cursorStyleBoolean",
		/* [4] */
		"FALSE",
		/* [5] */
		"TRUE"
	}
};

resource 'STR#' (31001, "Config: French") {
	{	/* array StringArray: 5 elements */
		/* [1] */
		"frenchOnlineBoolean",
		/* [2] */
		"frenchScreen132Boolean",
		/* [3] */
		"frenchCursorStyleBoolean",
		/* [4] */
		"Faux",
		/* [5] */
		"Vrai"
	}
};

resource 'DITL' (31000, "TConfig") {
	{ 	/* array DITLarray: 3 elements */
		/* [1] */
		{25,20,45,150},
		CheckBox {
			enabled,
			"Online?"
		},
		/* [2] */
		{50,20,70,150},
		CheckBox {
			enabled,
			"ScreenSize 132?"
		},
		/* [3] */
		{75,20,95,150}, 	/* top, left, bottom, right  */
		CheckBox {
			enabled,
			"Cursor Block?"
		}
	}
};